# sync-cnf-cert-and-preflight role

This role retrieves the operators that are autodiscovered in CNF Cert Suite execution through the claim.json generated by the certification. Then, it checks if these operators have already been defined in the `preflight_operators_to_certify` variable from [preflight role](../preflight/README.md), so that it appends the operators whose bundle_image has not been defined in that variable into a new list, called `preflight_operators_from_cnf_cert`, which is eventually appended to `preflight_operators_to_certify` in preflight.

Note that this role only appends the operators whose bundle_image does not appear in `preflight_operators_to_certify` variable. If any of them appears on that list, it will be omitted and not appended to `preflight_operators_from_cnf_cert`, to avoid duplicities.

> This role can be used with CNF Cert Suite versions from v4.0.0 till v4.1.5, as newer releases will directly run preflight on tnf container, so this is not longer needed there. If you are using a version different than these ones, even if you set up the variables above correctly, the role execution will be omitted.

## Variables

Name                                  | Default                                              | Description
------------------------------------- | ---------------------------------------------------- | -------------------------------------------------------------
sync\_cnf\_cert\_and\_preflight       | false                                                | If true, CNF Cert Suite output (claim.json file) would be used to create the `preflight_operators_to_check` variable needed for preflight tests.
preflight\_operators\_from\_cnf\_cert | []                                                   | It contains the operators that are autodiscovered by CNF Cert Suite execution and that are not included in `preflight_operators_to_certify`. It follows the same structure than `preflight_operators_to_certify`. Check [preflight README](../preflight/README.md) for more information.
cnf\_operators\_regex                 | "claim.configurations.testOperators"                 | Regex to filter operators from claim.json file from CNF Cert Suite.
